<?php


namespace FiloBlu\PaymentMethodFilter\Observer\Checkout;

class CartProductAddBefore implements \Magento\Framework\Event\ObserverInterface
{
    /**
     * @var \Magento\Checkout\Model\SessionFactory
     */
    protected $checkoutSessionFactory;

    /**
     * @var \FiloBlu\PaymentMethodFilter\Helper\PaymentFilter
     */
    protected $helper;

    public function __construct(
        \Magento\Checkout\Model\SessionFactory $sessionFactory,
        \FiloBlu\PaymentMethodFilter\Helper\PaymentFilter $helper
)
    {
        $this->checkoutSessionFactory = $sessionFactory;
        $this->helper = $helper;
    }

    /**
     * Prevent adding a gift card if I am paying with a gift card.
     *
     * @param \Magento\Framework\Event\Observer $observer
     * @return void
     */
    public function execute(
        \Magento\Framework\Event\Observer $observer
    ) {
        $requestInfo = $observer->getData('info');
        /** @var \Magento\Catalog\Model\Product $product */
        $product = $observer->getData('product');
        $quote = $this->checkoutSessionFactory->create()->getQuote();
        if ($this->helper->isGiftcardBuyingPrevented() && $this->helper->isPayingWithGiftcard($quote) && $product->getTypeId() == 'giftcard') {
            throw new \Magento\Framework\Exception\LocalizedException(__('Sorry, you cannot buy a gift card using a gift card.'));
        }
    }
}